#!/usr/bin/php
<?php
if (isset($_SERVER['REMOTE_ADDR'])) {
    die('Direct access not permitted');
}
// This script will simulate a house consumption meter if you own a total meter (import/export) and a production meter.

// Set the new house consumption meter
$HOUSEID      = 'Elect'; // ID
$HOUSEmetnum  = 1; // meter number
// Production
$PRODID       = '4'; // ID
$PRODcmd      = 'pool123s energy'; // Energy command
$POWERPRODcmd = 'pool123s power'; // Power
$PRODmetnum   = 4; // meter number
// TOT
$TPID         = 'TOT';
$TOTPOWERcmd  = 'more /tmp/485metern1.txt | egrep "^TOT\(" | grep "*W)"'; // return the total power (eg if import = 45W, export -55W)

// Import
$IMPID     = 'EIMP';
$IMPcmd    = 'more /tmp/485metern1.txt | egrep "^EIMP\(" | grep "*Wh)"';
$IMPmetnum = 5;
// Export
$EXPID     = 'EEXP';
$EXPcmd    = 'more /tmp/485metern1.txt | egrep "^EEXP\(" | grep "*Wh)"';
$EXPmetnum = 6;

// No edit should be needed bellow

function isvalid($id, $datareturn) //  IEC 62056 data set structure
{
    $regexp = "/^$id\(-?[0-9\.]+\*[A-z0-9%]+\)$/i"; //ID(VALUE*UNIT)
    if (preg_match($regexp, $datareturn)) {
        $datareturn = preg_replace("/^$id\(/i", '', $datareturn, 1); // VALUE*UNIT)
        $datareturn = preg_replace("/\*[A-z0-9%]+\)$/i", '', $datareturn, 1); // VALUE
        settype($datareturn, 'float');
    } else {
        $datareturn = null;
    }
    return $datareturn;
}

if (isset($argv[1])) {
    if ($argv[1] == 'power') {
        $datareturn = exec($TOTPOWERcmd);
        $datareturn = trim($datareturn);
        $totpower   = isvalid($TPID, $datareturn);
        
        $datareturn = exec($POWERPRODcmd);
        $datareturn = trim($datareturn);
        $prodpower  = isvalid($PRODID, $datareturn);
        
        $power = $prodpower + $totpower;
        $str   = utf8_decode("$HOUSEID($power*W)\n");
    } elseif ($argv[1] == 'energy') {
        define('checkaccess', TRUE);
        include('../config/config_main.php');
        date_default_timezone_set($DTZ);
        
        include("../config/config_met$IMPmetnum.php");
        include("../config/config_met$EXPmetnum.php");
        include("../config/config_met$PRODmetnum.php");
        
        $dir    = '../data/csv';
        $output = array();
        $output = glob($dir . '/*.csv');
        sort($output);
        $cnt = count($output);
        
        if (file_exists($output[$cnt - 1])) {
            $import     = null;
            $export     = null;
            $production = null;
            
            $lines      = file($output[$cnt - 1]); // today
            $contalines = count($lines);
            if ($contalines > 2) {
                $lastarray = preg_split("/,/", $lines[$contalines - 1]);
                
                $year  = substr($output[$cnt - 1], -12, 4);
                $month = substr($output[$cnt - 1], -8, 2);
                $day   = substr($output[$cnt - 1], -6, 2);
            } elseif ($contalines == 1 && file_exists($output[$cnt - 2])) { // yesterday, only header
                $lines      = file($output[$cnt - 2]);
                $contalines = count($lines);
                
                $lastarray = preg_split("/,/", $lines[$contalines - 1]);
                
                $year  = substr($output[$cnt - 2], -12, 4);
                $month = substr($output[$cnt - 2], -8, 2);
                $day   = substr($output[$cnt - 2], -6, 2);
            } elseif ($contalines == 2 && file_exists($output[$cnt - 2])) { // yesterday, header + only one data line	
                $lastarray = preg_split("/,/", $lines[$contalines - 1]);
                
                $lines      = file($output[$cnt - 2]);
                $contalines = count($lines);
                $prevarray  = preg_split("/,/", $lines[$contalines - 2]);
                
                $year  = substr($output[$cnt - 1], -12, 4);
                $month = substr($output[$cnt - 1], -8, 2);
                $day   = substr($output[$cnt - 1], -6, 2);
            } else {
                $year  = 0;
                $month = 0;
                $day   = 0;
            }
            $hour    = substr($lastarray[0], 0, 2);
            $min     = substr($lastarray[0], 3, 2);
            $UTCdate = strtotime($year . '-' . $month . '-' . $day . ' ' . $hour . ':' . $min);
            
            $nowutc = strtotime(date('Ymd H:i:s'));
            
            if ($nowutc - $UTCdate < 330) {
                $datareturn = null;
                $val        = null;
                $import     = null;
                $export     = null;
                $production = null;
                
                // Retrieve latest import
                $datareturn = exec($IMPcmd);
                $datareturn = trim($datareturn);
                $import     = isvalid($IMPID, $datareturn);
                
                // Retrieve latest export
                $datareturn = exec($EXPcmd);
                $datareturn = trim($datareturn);
                $export     = isvalid($EXPID, $datareturn);
                
                // Retrieve latest production
                $datareturn = exec($PRODcmd);
                $datareturn = trim($datareturn);
                $production = isvalid($PRODID, $datareturn);
                
                if (isset($import) && isset($export) && isset($production)) {
                    $import_lastcsv = trim($lastarray[$IMPmetnum]);
                    $export_lastcsv = trim($lastarray[$EXPmetnum]);
                    $prod_lastcsv   = trim($lastarray[$PRODmetnum]);
                    
                    if ($import_lastcsv == '') {
                        $import_lastcsv = null;
                    }
                    if ($export_lastcsv == '') {
                        $export_lastcsv = null;
                    }
                    if ($prod_lastcsv == '') {
                        $prod_lastcsv = null;
                    }
                    if ($export_lastcsv == '') {
                        $export_lastcsv = null;
                    }
                    if ($lastarray[$HOUSEmetnum] == '') {
                        $lastarray[$HOUSEmetnum] = null;
                    }
                    if (isset($lastarray[$HOUSEmetnum]) && isset($import_lastcsv) && isset($export_lastcsv) && isset($prod_lastcsv)) { // Avoid null values if skipped or missing a data
					settype($import_lastcsv, 'float');
                    settype($export_lastcsv, 'float');
                    settype($prod_lastcsv, 'float');
                        
                        if ($import >= $import_lastcsv) {
                            $import -= $import_lastcsv;
                        } else {
                            $import += ${'PASSO' . $IMPmetnum} - $import_lastcsv;
                        }
                        if ($export >= $export_lastcsv) {
                            $export -= $export_lastcsv;
                        } else {
                            $export += ${'PASSO' . $EXPmetnum} - $export_lastcsv;
                        }
                        if ($production >= $prod_lastcsv) {
                            $production -= $prod_lastcsv;
                        } else { // counter pass over
                            $production += ${'PASSO' . $PRODmetnum} - $prod_lastcsv;
                        }
                        
                        $val = $import + $production - $export;
                        settype($lastarray[$HOUSEmetnum], 'float');
                        settype($val, 'float');
                        $val += $lastarray[$HOUSEmetnum];
                        if ($val > ${'PASSO' . $HOUSEmetnum}) {
                            $val -= ${'PASSO' . $HOUSEmetnum};
                        }
                    } else { // Retrieve the last know HOUSEmet value
                        $j = 0;
                        while (!isset($val)) {
                            $j++;
                            $array = preg_split('/,/', $lines[$contalines - $j]);
                            $val   = trim($array[$HOUSEmetnum]);
                            if ($val == '') {
                                $val = null;
                            }
                            if ($j == $contalines - 1) {
                                $val = 0;
                            }
                        }
                    }
                    $str = utf8_decode("$HOUSEID($val*Wh)\n");
                } else {
                    die("Error: Retriving latest values\n");
                }
            } else {
                die("Error: Too late date value in csv\n");
            }
        } else {
            die("Error: No csv file\n");
        }
    } else {
        die("Abording: no valid argument given\n");
    }
    echo "$str";
} else {
    die("Usage: housepower { power | energy }\n");
}
?>